// $Id: ExecuteQueryServlet.java,v 1.2 2007-08-24 12:39:51 pierre Exp $

package com.senellart.pierre.fuzzyxml.demo;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.w3c.dom.Document;

import com.senellart.pierre.fuzzyxml.query.Query;

public class ExecuteQueryServlet extends FuzzyXMLServlet {
	static final long serialVersionUID = -5667796383592465511L;

	protected void doGet(HttpServletRequest req, HttpServletResponse res)
			throws ServletException, IOException {
		super.doGet(req, res);

		try {
			Query query = documentManager.getQueryFactory().newQuery(
					req.getParameter("query"),req.getParameter("join"));

			Document result = query.execute(documentManager
					.getDocument("pubs.xml"));

			File dotFile = createDotFile();

			environment.fuzzyxml2dot(result, new FileOutputStream(dotFile), true);

			returnImage(res, dotFile);
		} catch (Exception e) {
			throw new ServletException(e);
		}
	}
}
