// $Id: QizXQueryFactory.java,v 1.1.1.1 2006-03-22 13:32:17 pierre Exp $

package com.senellart.pierre.fuzzyxml.query;

import javax.xml.transform.Source;

import net.axyana.qizxopen.util.QName;
import net.axyana.qizxopen.xquery.XQType;
import net.axyana.qizxopen.xquery.XQueryBasicEngine;
import net.axyana.qizxopen.xquery.XQueryConnection;

import com.senellart.pierre.fuzzyxml.FuzzyXML;
import com.senellart.pierre.fuzzyxml.document.DocumentManager;
import com.senellart.pierre.fuzzyxml.exception.FuzzyXMLConfigurationException;
import com.senellart.pierre.fuzzyxml.exception.InvalidQueryException;

public class QizXQueryFactory extends QueryFactory {
	protected XQueryBasicEngine engine;

	protected XQueryConnection connection;

	public QizXQueryFactory(DocumentManager documentManager)
			throws FuzzyXMLConfigurationException {
		super(documentManager);

		try {
			XQueryBasicEngine engine = new XQueryBasicEngine();
			engine.startup();
			connection = engine.getConnection(null);
			connection.defineNamespace("fxml", FuzzyXML.NAMESPACE_URI);
			connection.defineGlobal(QName.get("document"), XQType.STRING);
		} catch (Exception e) {
			throw new FuzzyXMLConfigurationException(e);
		}
	}

	public XQueryConnection getConnection() {
		return connection;
	}

	public Query newQuery(DocumentManager documentManager, Source query) throws InvalidQueryException {
		return new QizXQuery(documentManager, query);
	}
}
