// $Id: XSLTUpdateFactory.java,v 1.1.1.1 2006-03-22 13:32:17 pierre Exp $

package com.senellart.pierre.fuzzyxml.update;

import java.io.FileInputStream;
import java.io.InputStream;

import javax.xml.transform.Transformer;
import javax.xml.transform.stream.StreamSource;

import org.w3c.dom.Document;

import com.senellart.pierre.fuzzyxml.FuzzyXMLEnvironment;
import com.senellart.pierre.fuzzyxml.document.DocumentManager;
import com.senellart.pierre.fuzzyxml.exception.FuzzyXMLConfigurationException;
import com.senellart.pierre.fuzzyxml.exception.InvalidUpdateException;

public class XSLTUpdateFactory extends UpdateFactory {
	Transformer xUpdateXSLTEngine;

	public XSLTUpdateFactory(DocumentManager documentManager)
			throws FuzzyXMLConfigurationException {
		super(documentManager);

		FuzzyXMLEnvironment environment = documentManager.getEnvironment();

		try {
		xUpdateXSLTEngine = environment.getXSLTFactory().newTransformer(
				new StreamSource(new FileInputStream(environment.getPath()
						+ "/xsl/xupdate.xsl")));
		} catch(Exception e) {
			throw new FuzzyXMLConfigurationException(e);
		}
	}

	public Update newUpdate(InputStream update) throws InvalidUpdateException {
		return new XSLTUpdate(documentManager, update);
	}

	public Update newUpdate(Document update) throws InvalidUpdateException {
		return new XSLTUpdate(documentManager, update);
	}
	
	public Transformer getXUpdateXSLTEngine() {
		return xUpdateXSLTEngine;
	}
}
